<template>
  <div>
    <div class="group-list-wrapper">
      <div class="groups-drag-drop">
        <ul class="list">
          <li v-for="zone in zoneList" :key="zone.id" class="item">
            <CCard>
              <CCardHeader>
                <div class="card-header-title">
                  <font-awesome-icon :icon="['fas', 'th']" />
                  {{ zone.name }}
                </div>
                <div class="card-header-actions">
                  <CSwitch
                    :id="zone.id"
                    :checked="zone.status === 1"
                    color="primary"
                    variant="3d"
                    shape="pill"
                    label-on="On"
                    label-off="Off"
                    @update:checked="onChangeStatusZone"
                  />
                </div>
              </CCardHeader>

              <CCardBody>
                <draggable
                  :id="zone.id"
                  v-model="zone.groups"
                  class="list-group"
                  group="zoneList"
                  @end="onChangePositionGroup"
                >
                  <div
                    v-for="group in zone.groups"
                    :id="group.id"
                    :key="group.id"
                    class="list-group-item"
                    ghost-class="ghost"
                  >
                    <div class="txt-name">
                      <font-awesome-icon :icon="['fas', 'sitemap']" class="width-1x" />
                      {{ group.name }}
                    </div>
                    <ul class="row no-gutters box-detail">
                      <li class="col-6">
                        <CBadge :color="`${group.status === 1 ? 'primary' : 'secondary'}`">
                          {{ group.status === 1 ? 'ON' : 'OFF' }}
                        </CBadge>
                      </li>
                      <!-- <li class="col-4">
                        <font-awesome-icon :icon="['fas', 'check-circle']" class="width-1x" />
                        <span> 00 Things</span>
                      </li> -->
                      <li class="col-6 text-right">
                        <CSwitch
                          :id="group.id"
                          :checked="group.status === 1"
                          color="primary"
                          variant="3d"
                          shape="pill"
                          label-on="On"
                          label-off="Off"
                          @update:checked="onChangeStatusGroup"
                        />
                      </li>
                    </ul>
                    <ul class="btns-action">
                      <li>
                        <div class="btn text-primary" @click="onShowDetail(group.id)">
                          <font-awesome-icon :icon="['fas', 'pencil-alt']" />
                        </div>
                      </li>
                      <li>
                        <div class="btn text-danger" @click="onConfirmDelete(group.id)">
                          <font-awesome-icon :icon="['fas', 'trash-alt']" />
                        </div>
                      </li>
                    </ul>
                  </div>
                </draggable>
                <div class="box-action">
                  <button class="btn-add-children" @click="onShowDetail(0)">
                    <font-awesome-icon :icon="['fas', 'plus-circle']" class="width-1x" />
                    Add another group
                  </button>
                </div>
              </CCardBody>
            </CCard>
          </li>
        </ul>
      </div>
    </div>

    <app-delete-confirm-dialog
      ref="deleteConfirmDialog"
      :name="'group'"
      @confirm="onDelete"
    />

    <group-detail-modal
      :id="selectedId"
      ref="groupDetailModal"
    />
  </div>
</template>

<style lang="scss" scoped>
  .group-list-wrapper {
    min-height: 200px;
  }
</style>

<script>
import draggable from 'vuedraggable'

import AppDeleteConfirmDialog from '~/components/molecules/AppDeleteConfirmDialog'
import GroupDetailModal from '~/components/organisms/groups/GroupDetailModal'

export default {
  components: {
    draggable,
    AppDeleteConfirmDialog,
    GroupDetailModal
  },

  data () {
    return {
      resourceTypeName: 'group',
      zoneList: [],
      selectedId: null
    }
  },

  mounted () {
    this.getZoneList()
  },

  methods: {
    /**
     * Call API get groups
     */
    getZoneList () {
      this.$dam.getZoneList()
        .then((res) => {
          if (Array.isArray(res.data) && res.data.length) {
            this.zoneList = res.data
          }
        })
        .catch((err) => {
          console.error(err)

          this.$toast.error(
            this.$text.error('FAILED_TO_GET', { name: 'zone list' })
          )
        })
    },

    /**
     * Event when change position of group
     *
     * @param {Object} event - Event object of drag and drop
     */
    onChangePositionGroup (event) {
      if (!event.item.id || event.from.id === event.to.id) {
        return
      }

      const params = {
        id: +event.item.id,
        zone_id: +event.to.id
      }
      this.$dam.updateGroup(params)
        .then((res) => {
          this.$toast.success(
            this.$text.info('UPDATED', { name: this.resourceTypeName })
          )
        })
        .catch((err) => {
          console.error(err)

          this.$toast.error(
            this.$text.error('FAILED_TO_UPDATE', { name: this.resourceTypeName })
          )

          this.getZoneList()
        })
    },

    /**
     * Event when change status of group
     *
     * @return {Boolean} val - True if checkbox is checked, else false
     * @return {Object} event - Event object of checkbox
     */
    async onChangeStatusGroup (val, event) {
      if (!event.target.id) {
        return
      }

      try {
        let res = null

        if (val === true) {
          res = await this.$dam.groupOn({
            id: +event.target.id,
            status: 1
          })
        } else {
          res = await this.$dam.groupOff({
            id: +event.target.id,
            status: 0
          })
        }

        if (res && res.data && res.data.id) {
          // Change label state of current group on page
          this.zoneList.forEach((zone) => {
            zone.groups.map((group) => {
              if (group.id === res.data.id) {
                group.status = (val === true ? 1 : 0)
                return group
              }
            })
          })

          this.$toast.success(
            this.$text.info('UPDATED', { name: this.resourceTypeName })
          )
        }
      } catch (err) {
        console.error(err)

        this.$toast.error(
          this.$text.error('FAILED_TO_UPDATE', { name: this.resourceTypeName })
        )
      }
    },

    /**
     * Event when change status of zone
     *
     * @return {Boolean} val - True if checkbox is checked, else false
     * @return {Object} event - Event object of checkbox
     */
    async onChangeStatusZone (val, event) {
      if (!event.target.id) {
        return
      }

      try {
        let res = null

        if (val === true) {
          res = await this.$dam.zoneOn({
            id: +event.target.id,
            status: 1
          })
        } else {
          res = await this.$dam.zoneOff({
            id: +event.target.id,
            status: 0
          })
        }

        if (res && res.data && res.data.id) {
          // Change label and switch button state of all groups on page
          this.zoneList.forEach((zone, indexZ) => {
            if (zone.id === res.data.id) {
              this.zoneList[indexZ].groups.map((group, indexG) => {
                group.status = (val === true ? 1 : 0)
                return group
              })
            }
          })

          this.$toast.success(
            this.$text.info('UPDATED', { name: 'zone' })
          )
        }
      } catch (err) {
        console.error(err)

        this.$toast.error(
          this.$text.error('FAILED_TO_UPDATE', { name: 'zone' })
        )
      }
    },

    /**
     * Open group detail modal
     *
     * @param {Object} group - Current group
     */
    onShowDetail (id) {
      this.setSelectedId(id)
      this.$refs.groupDetailModal.open()
    },

    /**
     * Open confirm delete
     * If confirm then call delete group
     * Else cancel
     *
     * @param {String} id - group id
     */
    onConfirmDelete (id) {
      this.setSelectedId(id)
      this.$refs.deleteConfirmDialog.open()
    },

    /**
     * After the deletion confirmation dialog is confirmed
     */
    onDelete () {
      if (this.selectedId) {
        this.$dam.deleteGroup({ id: this.selectedId })
          .then((_) => {
            this.$toast.success(
              this.$text.info('DELETED', { name: this.resourceTypeName })
            )

            this.getZoneList()
          })
          .catch((err) => {
            console.error(err)

            this.$toast.error(
              this.$text.error('FAILED_TO_DELETE', { name: this.resourceTypeName })
            )
          })
      }
    },

    /**
     * Set select id
     *
     * @param {Number} id - Group id
     */
    setSelectedId (id) {
      this.selectedId = id
    }
  }
}
</script>
